﻿--Bar creation module

local width, height = 250, 18

function SN:SNCreateBG(frame)
	if(IsAddOnLoaded("ElvUI")) then
		local bg = CreateFrame("Frame")
		bg:SetTemplate("Default")
		bg:SetParent(frame)
		bg:ClearAllPoints()
		bg:Point("TOPLEFT", frame, "TOPLEFT", -2, 2)
		bg:Point("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 2, -2)
		bg:SetFrameStrata("LOW")
		bg:Show()
	end
end

function SN:CreateBar(group, cooldown, duration, caster, guid, spell)
	local v = SN.Media
	--print(caster)
	--Start the CD Timer
	local bar = SN.timers:NewBar(group, width, height, v.media.minTex)
	bar:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	local class, classFileName = UnitClass(caster)
	local colortmp = RAID_CLASS_COLORS[classFileName]
	color = { colortmp.r, colortmp.g, colortmp.b }

	bar:SetIcon(select(3, GetSpellInfo(cooldown['spellID'])))
	bar:SetData("SN:arg1", group)
	bar:SetData("SN:arg2", cooldown)
	bar:SetData("SN:arg3", guid)
	bar:SetData("SN:arg4", caster)
	bar:SetData("SN:arg5", spell)
	bar:SetColor(color)
	
	bar:SetDuration(duration)
	bar:SetLabelFont(v.media.font, 14, "OUTLINE")
	bar:SetLabel(spell)
	SN:SNCreateBG(bar)
	bar.TimeSinceLastUpdate = 0
	bar.RegisterCallback(self, "FancyBar_BarStop", "CleanUpBars")
	bar:SetScript("OnEvent", function(self, event, ...)
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			local _, type, _, _, _, _, _, destGUID, destname, _, _ = ...
			if type == "UNIT_DIED" then
				--print("Did he die?")
				--print(destGUID)
				--print(self:GetData("SN:arg3"))
				if destGUID == self:GetData("SN:arg3") then
					--print(self:GetData("SN:arg1"))
					self:Stop()
					--local grp = self:GetData("SN:arg1")
					--grp:Remove(self)
				end
			end
		end	
	end)
	bar:Start()
	
end

function SN:CleanUpBars(callback, bar)

end

function SN:StartCD(group, cooldown, duration, guid, caster, spell, type)

	if(SN.V.defaults.profile.CD.castannounce) then
		local name = select(1, GetSpellInfo(cooldown['spellID']))
	
		if GetNumGroupMembers() > 1 and IsInRaid() then
			SendChatMessage(caster.." Casts "..name.." "..duration.."Min".." CD" ,"RAID")
		else
			SendChatMessage(caster.." Casts "..name.." "..duration.."Min".." CD" ,"PARTY")
		end
	end

	local bar = SN:CreateBar(group, cooldown, duration, caster, guid, spell)
	
end